您的位置:首页 > 其它

hdu 1856 并查集(很裸)(路径压缩)

2015-09-21 19:03 260 查看
Mr Wang wants some boys to help him with a project. Because the project is rather complex,
the more boys come, the better it will be. Of course there are certain requirements.

Mr Wang selected a room big enough to hold the boys. The boy who are not been chosen has to leave the room immediately. There are 10000000 boys in the room numbered from 1 to 10000000 at the very beginning. After Mr Wang's selection any two of them who are
still in this room should be friends (direct or indirect), or there is only one boy left. Given all the direct friend-pairs, you should decide the best way.

Input

The first line of the input contains an integer n (0 ≤ n ≤ 100 000) - the number of direct friend-pairs. The following n lines each contains a pair of numbers A and B separated by a single space that suggests A and B are direct friends.
(A ≠ B, 1 ≤ A, B ≤ 10000000)

Output

The output in one line contains exactly one integer equals to the maximum number of boys Mr Wang may keep.

Sample Input

4
1 2
3 4
5 6
1 6
4
1 2
3 4
5 6
7 8


Sample Output

4
2


Hint

A and B are friends(direct or indirect), B and C are friends(direct or indirect), then A and C are also friends(indirect). In the first sample {1,2,5,6} is the result. In the second sample {1,2},{3,4},{5,6},{7,8} are four kinds of answers.

题意;就是找一个树根上所连的结点最多是多少;
思路:很好想到并查集,既然在一个树根上,那我比较树根上的节点数目就好了,自己觉得很简单就写了代码结果TLE,主要是没有用到路径压缩,问了别人什么是路径压缩,
个人理解是:如果儿子和爸爸都在爷爷的保护下,那就把儿子也连在爷爷的下面,让儿子和爸爸是已被就好了,防止数退化成链表,减少递归的次数就可以减少时间。
理解清楚了写了,WA了,后来发现是如果输入0,那么他认识的人就是1.然后果断AC.

总结:单纯的想法一定会导致单纯的错误,没有对概念的深入理解,不能获得更多的东西,胜利属于那些坚持不懈,继续努力的人。。


AC代码

#include <iostream>

#include <cstdio>

#include <cstring>

using namespace std;

int a[10000002];

int b[10000002];

int sum;

int found(int x){

if(x == a[x]){

return a[x];

}

return a[x] = found(a[x]);//把儿子的爸爸弄成爷爷

}

void bing (int x,int y){

int xx = found (x);

int yy = found (y);

a[xx] = yy;

b[yy] = b[xx] + b[yy];

if(sum < b[yy]){

sum = b[yy];//最大的根节点

}

}

int main(){

int n;

while(~scanf("%d",&n)){

if(n == 0){

printf("1\n");

continue;

}

for(int i = 1; i < 10000001;++i){

a[i] = i;

b[i] = 1;

}

int aa,bb;

sum = 0;

while(n--){

scanf("%d%d",&aa,&bb);

if(found(aa) != found(bb)){

bing(aa,bb);

}

}

printf("%d\n",sum);

}

return 0;

}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: